### v1.57.0 - 2026-06-01

- help: verb 'keys' and 'description' columns now searchable - Fix #1163
- fix `:print_path` / `:print_relative_path` adding a trailing empty line when printing a multi-item staging area - Fix #1062 - Thanks @xfocus3
- Skin: attributes (bold, underlined, etc.) of the "selected_line" entry now applied - Fix #1156
- if no Wezterm version is found, broot now assumes it's recent enough to support kitty protocol for image - Fix #509 - Thanks @chinhkrb113

### v1.56.4 - 2026-05-14

- fix compilation on non unix platforms (1.56.3 isn't available on those systems)

### v1.56.3 - 2026-05-13

- fix control characters sometimes remaining in the terminal after broot exit
- nushell: rename br module to avoid conflict in last nushell version - Fix #1138 - Thanks @paulhey
- `:open_stay` on the staging area opens every staged file through the system opener - Fix #444 - Thanks @ChrisJr404

### v1.56.2 - 2026-03-26

- `{file-root-relative}` argument - Fix #1142
- fix `:clear_stage` (or other operations closing the stage panel) often closing broot - Fix #1143

### v1.56.1 - 2026-03-20

- fix a typo in a verb in default conf

### v1.56.0 - 2026-03-20

- `impacted_panel` verb argument, allows the effect of a verb to be on another panel (eg to scroll the preview panel without removing the focus from the tree) - Fix #1119
- `focus_panel_left` and `focus_panel_right` internals - Fix #1115
#### Major Feature: merge staged files to issue a single command
When a verb argument has a `space-separated` or `comma-separated` flag, a single external command is run even when the selection is multiple - Fix #465
The default `verbs.json` file has an example of a `zip` verb building an archive from all staged files.

### v1.55.0 - 2026-02-09

- activate Kitty Graphics Protocol to display Hi-Res images in iTerm2 - Thanks @kidonng
- Tokyo Night skin ( https://github.com/Canop/broot/blob/main/resources/default-conf/skins/tokyo-night.hjson ) - Thanks @hb-hello
- matches related to several name patterns joined with and/or in a composite pattern are merged instead of having just the first one shown - Thanks @Tomaz-Vieira
- nushell integration: switch $nu.temp-path to $nu.temp-dir - #1116 - Thanks @stevenxxiu

### v1.54.0 - 2025-12-03

- fix crash on rendering B&W images with Kitty image protocol
- don't match directories when a composite pattern has a content pattern, even negated (eg `/js$/&!c/;`: it's clear the user wants to match js *files* not containing a semicolon)

### v1.53.0 - 2025-11-08

- fix some cases of the verb not removed from the input on execution (with a risk of accidental double execution)
- add the `:filesystems` (short `:fs`) verb and state on windows (it was already present on linux and mac).
- improve the generation of preview pattern from a file tree pattern (i.e. going from `/java$/&c/test` to `/test` on opening a matching file in preview). With this change broot avoids filtering the preview when it shouldn't (eg when you searched `/java$/|c/test`) - See #1097
- display files whose name isn't valid UTF-8 (they were previously ignored)
- android executable is back to the official binary archive

### v1.52.0 - 2025-11-01

- `auto_open_staging_area` preference - Fix #1090
- search content of file target of symlink - Fix #1081
- fix nushell script (swapped logic for --listen and --listen-auto) - Thanks @cderwin
- return non-zero exit code on error - Thanks @Sambhram1

### v1.51.0 - 2025-10-05

- improved image rendering (both speed by using the zune-image library, and quality with bilinear interpolation)
- fix compilation broken by 1.50.0 on Android- thanks @dead10ck
- `--listen-auto` listens for commands on a random linux socket - Fix #1064
- when auto-completing, `back-tab` cycles in reverse order - Fix #1071

### v1.50.0 - 2025-09-25

- big text files now only partially loaded for initial display, remaining being done in background - Fix #1052
- better support of kitty image protocol over tmux, ssh or unknown terminals, with  `kitty_graphics_display` option and `$TMUX_NEST_COUNT` env variable - see PR #1034 - Thanks @stevenxxiu
- "trash" compilation feature removed: trash related features are built depending on the platform
- build chain revised. Future official releases should include a Mac binary
- fix crash on double unstage of last entry in stage panel - fix #1057
- fallback to transparent background for text preview when the skin specifies nothing - Thanks @letmeiiiin

### v1.49.1 - 2025-09-15

- watching made much more efficient (some deep changes won't lead to an automatic refresh which only impacts dir size)
- the name given with `--listen` is now provided to verb as the `{server-name}` verb argument

### v1.49.0 - 2025-09-13

- `:toggle_watch` internal, with `:watch` shortcut, bound by default to `alt-w`. When watching is active, the tree is refreshed whenever any directory/file, even deep, is changed - Fix #730
- fallback to a transparent background for images in image preview instead of a specific color - Fix #1040 - Thanks @letmeiiiin
- fix --server socket written at a non writable location on Android/termux - Fix #1045

### v1.48.0 - 2025-08-29

- Support for the 'Cmd' modifier in key shortcuts (the key is called 'Command', 'Super', 'Apple', 'Windows', depending on systems and users)
- "filesystem" features have been made available for Mac:
    - the `:fs` screen, listing filesystems
    - filesystem free space & total space displayed when size computations are requested
    - device id displayed with `:toggle_device_id` (shortcut: "dev")
- Fix `.config/git/ignore` not being loaded on Mac - Fix #1032 - Thanks @9999years

### v1.47.0 - 2025-06-26

- text files with control chars were previously previewed as binary. They're now displayed as text with some '�' when needed - Fix #977
- files with ANSI escape codes (such as the one you would obtain with `dysk --color yes > ansi.txt` can now be previewed with `:preview_tty` - Fix #1019
- first line of the tree is cropped (right aligned) when it doesn't fit

### v1.46.5 - 2025-05-30

- fix `:focus some/path` called in a command sequence always opening new panel - Fix #1014

### v1.46.4 - 2025-05-14

- support for keys F13 to F24 (if your system supports it)
- fix `:focus` with argument given in configuration going up one level when root is selected - Fix #1009
- fix `--max-depth` ignored when in `default_flags` - Fix #1013

### v1.46.3 - 2025-04-24

- fix broot waiting for events on internals like `:quit` - Fix #1006

### v1.46.2 - 2025-04-21

- fix broken nushell script (`--max-depth` again) - Thanks @sandyspiers & @amitkot

### v1.46.1 - 2025-04-20

- fix nushell script broken by new `--max-depth` argument - Thanks @lizclipse

### v1.46.0 - 2025-04-16

- `:set_max_depth <number>` and `:unset_max_depth` - Fix #843 - Thanks @mcky
- clear cache when files are deleted in staging area - Fix #999
- recompute preview transform when source file changed since last preview

### v1.45.1 - 2025-03-25

- Fix compilation failing without `--locked` - Fix #995

### v1.45.0 - 2025-03-17

- Fix total search impossible to redo after refresh - Fix #986
- With `refresh_after: false`, a verb configuration can request that the tree isn't refreshed after its execution - Fix #987

### v1.44.7 - 2025-02-12

- fix bad regex match position - Fix #979
- update resvg dependency to 0.44 - Thanks @NoisyCoil
- on `--server`, remove the existing socket if it already exists - Thanks @VasilisManol

### v1.44.6 - 2025-01-12

 -fix .ignore files ignored when not in a git repository - Fix #970
 -update git2 dependency to 0.20 - Fix #974

### v1.44.5 - 2025-01-02

- no real change (just reverting a crate name to ease some packaging)

### v1.44.4 - 2025-01-01

- fix panic in preview on syntax coloring (when a sublime syntax isn't compatible with the regex engine) - Fix #967

### v1.44.3 - 2024-12-26

- removed default bindings on left and right keys. You may add them back by adding this to your verbs.hjson:
```Hjson
    { key: "left", internal: "back" }
    { key: "right", internal: "open_stay" }
```
- rustc minimal version changed from 1.76 to 1.79, which allows better performing image rendering
- remove dependency to onig, to allow compatibility with gcc 15 - Fix #956

### v1.44.2 - 2024-10-22

- temp files created for kitty now erased on quitting or when too many of them have been written
- no longer panics when launched with BROOT_LOG=debug but the broot.log file can't be created - Fix #951
- fix user and group names displayed as "????" when coming from openldap - Fix #953

### v1.44.1 - 2024-10-16

- fix wrong position of IMEs (input method editors) popup - thanks @xubaiwang - See #948
- improve querying the terminal for capabilities (prevent some escape chars from leaking)

### v1.44.0 - 2024-09-07

- `:focus_staging_area_no_open` internal, focus the staging area if it's already open, does nothing in other case - Fix #926
- fix some composite patterns with several operators and no parenthesis

### v1.43.0 - 2024-08-30

- 'Size' and 'Deletion date' columns in trash screen. This screen now supports the `:toggle_date`, `:toggle_size`, `:sort_by_date`, and `:sort_by_size` internals.
- new `:show` internal make the provided path visible and selected, adding lines to the tree if necessary, does nothing if the provided path is not a descendant of the current tree root (this part may change depending on feedback) - Fix #936

### v1.42.0 - 2024-08-18

- support of `.ignore` files with the same syntax than `.gitignore`. They have priority over `.gitignore` so that a personal `.ignore` file can override a shared `.gitignore` - See https://dystroy.org/broot/tree_view/#hidden-ignored-files - Fix #613
- `:toggle_ignore` internal, identical to `:toggle_git_ignore`, but with a clearer name so should be preferred
- the `panels` verb filter now works in most contexts (it was previously only checked on key events)
- many dependencies updated

### v1.41.1 - 2024-08-04

- allow compilation with rustc 1.76 - Fix #925

### v1.41.0 - 2024-08-04

#### Major Feature: :search_again
ctrl-s now triggers `:search_again` which either
- brings back the last used search pattern, when no filtering pattern is active
- does a "total search" if a filtering pattern is active and the search wasn't complete
#### Major Feature: internals changing panel widths
* `set_panel_width`, taking as parameter the index of the panel and the desired width
* `move_panel_divider`, taking as parameter the index of the divider and the desired change
`ctrl-<` is bound by default to `:move_panel_divider 0 -1`
`ctrl->` is bound by default to `:move_panel_divider 0 1`
See http://dystroy.org/broot/panels/#resize-panels
#### Minor Changes:
- when git file infos are shown, and git ignored files aren't hidden, those files are flagged with a 'I' - Fix #916
- Remove .bak extension from content search exclusion list - Fix #915
- Update nerdfont and vscode icons - Thanks @jpaju
- `{initial-root}` verb argument

### v1.40.0 - 2024-07-16

#### Major Feature: preview transformers
You can now define preview transformers to be applied before preview.
They allow for example previewing PDF or Office files, or beautifying JSON files.
Edit the `preview_transformers` array in your conf.hjson file.
See https://dystroy.org/broot/conf_file/#preview
#### Fixes
- fix search on root - Fix #904
- fix some verb cycling problems - Fix #902

### v1.39.2 - 2024-07-08

- fix UNC paths being displayed on Windows (regression at 1.39.1) - Fix #812 (again)

### v1.39.1 - 2024-07-05

- fix high-resolution (kitty protocole) image broken in release mode - Fix #885
- canonicalize paths when focusing them (mostly useful when following links)
- a few minor internal optimizations

### v1.39.0 - 2024-05-31

- `:open_trash` shows the content of the trash. Other new internals & verbs: `:delete_trashed_file`, `:restore_trashed_file`, `:purge_trash` - Fix #855
- it's now possible to remove a default keybinding by defining a verb with no execution - Fix #632
- fix build on Android - thanks @dead10ck

### v1.38.0 - 2024-05-04

- `-{flags}` verb lets you change the state the same way you do it at start, eg `:-sd` to show sizes and dates
- calling `:focus` on the tree root now goes up the tree (experimental)

### v1.37.0 - 2024-04-28

- optionally display lines surrounding a matching line in preview, with `lines_before_match_in_preview` and  `lines_after_match_in_preview` - Fix #756
- filtered preview: jump between matches with `:next_match` (default: `tab`) and `:previous_match` (default `shift-tab`)
- display setuid, setgid and sticky bits in permission - Fix #863, Thanks @Jisu-Woniu

### v1.36.1 - 2024-03-11

- fix ANSI code leaking to the input on start on Mac - Fix #854

### v1.36.0 - 2024-03-01

- releases at github should be more `cargo binstall` friendly - Thanks @FrancescElies
- improved `--help`
- new `:stage_all_directories` internal - Fix #844
- `:print_tree` is one line shorter, so as to let the original shell command visible without scroll
- fix and document the "kitty-csi-check" optional feature which can be enabled at compilation

### v1.35.0 - 2024-03-01

- Nerdfont icon theme - Fix #333 - Thanks @JonasLeonhard, @cho-m, @texastoland, @asdf8dfafjk and others

### v1.34.0 - 2024-02-24

- new `--verb-output` launch argument, dedicated to the new `:clear_output` and `:write_output` internals - Fix #825
- verb sequences (based on `cmd`) can take arguments from the verb invocation
- don't fail launch in case of bad verb configuration, more helpful error message in such case
- faster kitty image rendering by default - Fix #789
- `{file-git-relative}` verb argument - Thanks @VasilisManol
- modify nushell function import: `use` instead of `source` - Thanks @texastoland and @FrancescElies
- fix some resizing and flickering problems on Windows (appeared with 1.33.0) - Fix #840
- write `installed` flag file on `--install` - Fix #837

### v1.33.1 - 2024-02-03

- fix the release's version

### v1.33.0 - 2024-02-03

- on terminals supporting the kitty keyboard protocol, you can now define and use key combinations like `space-n`, `ctrl-alt-a-b`, `shift-space-c`, `ctrl-enter`, etc.
- new syntax for special paths - Fix #687, #669

### v1.32.0 - 2024-01-02

- with "modal" enabled, `initial_mode` setting lets you choose whether to start in `input` mode or `command` mode (default) - Fix #708

### v1.31.0 - 2023-12-30

- keep broot's work dir synchronized with the root of the current panel. Can be disabled in conf with `update_work_dir: false` - Fix #813
- fix `:trash` internal not working on staged files

### v1.30.2 - 2023-12-23

- don't canonicalize paths on windows on new panels - Fix #809

### v1.30.1 - 2023-12-03

- nushell script: replace the deprecated `def-env` with `def --env` - Thanks @melMass

### v1.30.0 - 2023-12-03

- `:trash` internal - I'd like feedback on this one - Fix #799
- solve symlinks on `:panel_right` to display the dest path and the dest filesystem - Fix #804
- `:panel_right` on a directory now removes the filter
- more '~' expansion in verb arguments

### v1.29.0 - 2023-11-22

- `terminal_title` option in configuration - Fix #794
- `:toggle_tree` internal and `--tree` and `--no-tree` launch flags (experimental, feedback welcome) - Fix #670 - Thanks @eldad
- `{git-name}` verb argument

### v1.28.1 - 2023-11-13

- fix a regression in handling of rooted gitignore patterns - Fix #795

### v1.28.0 - 2023-11-12

- left and right keys bound to verbs can be used when the input isn't empty, if they would have no effect to the input
- default_flags now accept long parameters, including --cmd - Fix #790
- gitignore: fix relative patterns with several tokens - Fix #782

### v1.27.0 - 2023-10-29

- the `apply_to` verb filter accepts new values: `text_file` and `binary_file`. Broot users editing files in their terminal (vi, emacs, etc.) should configure broot to open their text editor on `enter`: see https://dystroy.org/broot/tricks/#change-standard-file-opening
- small breaking change: `:stage_all_files` now stages also symlinks - Fix #606
- new `{git-root}` verb argument - Fix 760 - Thanks @9999years
- fix a freeze on windows when launching a search with `-c` - Thanks @3tilley
- fix automatic preview pattern not escaping spaces and colons - Fix #778

### v1.26.1 - 2023-09-30

- improved status line

### v1.26.0 - 2023-09-27

- when given a path to a file at launch, broot now selects it in the tree and opens it in preview - Fix #729
- allow rebinding of the 'tab' and 'esc' keys with the `:next_match` and `:escape` internals - Fix #740
- fix fuzzy patterns not case insensitive on some characters - Fix #746

### v1.25.2 - 2023-09-20

- optional BROOT_CONFIG_DIR env var - the site now shows all env variables: https://dystroy.org/broot/launch/#environment-variables
- `--only-folders` now longer allows symlinks to non directories - Fix #742

### v1.25.1 - 2023-09-03

- fix shift-char in input extending the selection - Fix #733

### v1.25.0 - 2023-08-19

- allow unescaped '::' in pattern position, experimental (might be removed)
- allow hexa color notation in skins (eg `#fb0` or `#FFD700`)

### v1.24.2 - 2023-07-18

- fix a case of br script installation failing on Windows/Powershell

### v1.24.1 - 2023-07-16

- slightly better `--help`

### v1.24.0 - 2023-07-16

- installer for the powershell br script on windows - Thanks @felixkroemer
- new `--help`, more compact
- allow extra spaces before the verb
- updated man page, now distributed in releases as /man/broot.1

### v1.23.0 - 2023-06-16

- prettier, faster SVG rendering
- reorganize default conf files, with a "skins" subfolder

### v1.22.1 - 2023-05-23

- allow dir computations in /run/media - Fix #704 - Thanks @jinliu
- fix included solarized-dark.hjson skin file

### v1.22.0 - 2023-05-18

- define disk space availability colors in skin - Fix #705
- left elision of path when path/name doesn't fit - Fix #700

### v1.21.3 - 2023-05-02

- `switch_terminal` verb parameter - Thanks @stevenxxiu
- on Windows, when using `-c`, clear events after delay - Fix #699

### v1.21.2 - 2023-03-30

- update dependencies because of some yanked ones

### v1.21.1 - 2023-03-23

- resolve `~` in special paths - Fix #685
- better clipboard support on MacOS - Thanks @bryan824

### v1.21.0 - 2023-03-17

- better nushell integration (no need to quote arguments anymore, fix path extension broken by new version of nushell) - Thanks @stevenxxiu
- don't show modal-only keys in help page when modal mode isn't enabled

### v1.20.2 - 2023-02-19

- fix debug statement printed in some cases (mostly on Windows) - Fix #672

### v1.20.1 - 2023-02-08

- fix status line not always displaying the hint of the input's verb - Fix #665

### v1.20.0 - 2023-02-03

- unless overridden, `/proc` is now `no-enter`, which solves freezes when searching on `/` in some system - See #639
- SVG files now rendered as images in the preview panel
- new version of the nushell function. You should be prompted for an update - Fix #656 - Thanks @FrancescElies and @mediumrarez
- `no-hide` special paths - Thanks @Avlllo
- preview can now be opened on directories, showing their first level - Fix #405
- better determine whether the terminal is white or dark in some (probably rare) cases - See https://github.com/Canop/terminal-light/issues/2

### v1.19.0 - 2023-01-03

- Nushell support - Fix #375 - Thanks @FrancescElies, @mediumrarez, and issue contributors

### v1.18.0 - 2022-12-21

- Hjson configuration file can now omit outside braces (it's "braceless Hjson"), making it much cleaner
- allow opening the help screen with just the `?` key on Windows (as for other systems)
- fix a crash in some cases of input being cleaned with a selection - Fix #643

### v1.17.1 - 2022-12-15

- Windows specific implementation of :cpp

### v1.17.0 - 2022-12-09

- max file size for content search now configurable (default is now 10MB) - Fix #626
- file summing now avoids /proc and /run
- default configuration sets /media as not entered by default (can be commented out, of course)

### v1.16.2 - 2022-11-04

- you can restrict the panels in which verbs apply with the verb configuration `panels` parameter
- fix rm on Windows behaving "recursively" (it was `cmd /c del /Q /S {file}`) - Fix #627

### v1.16.1 - 2022-10-13

- fix ctrl-left not usable anymore in filtered preview to remove filtering

### v1.16.0 - 2022-10-07

- status messages now displayed on toggling (for example showing hidden files)
- upgrade terminal-light to 1.0.1 for better recognition of background color on high precision color terminals
- in default configuration, ctrl-left never opens a panel to the left, as I think this was most often unwanted (one too many hit on cltr-left). It's possible to get the old behavior by binding ctrl-left to `:panel_left` instead of the new `:panel_left_no_open` internal.
- New escaping rules let you skip many `\`, especially when building regexes - See new rules at https://dystroy.org/broot/input/#escaping - Fix #592

### v1.15.0 - 2022-09-24

- with `show_matching_characters_on_path_searches: false`, it's possible to show only file names even when searching paths - Fix #490
- `--sort-by-type-dirs-first` and `--sort-by-type-dirs-last` - Fix #602
- modal: in input mode, uppercase letters don't trigger verbs anymore - Fix #604
- fix `:line_down_no_cycle` which was cycling - Fix #603
- selecting lines up or down with the mouse wheel now wraps in both direction (ie going up when your on top brings you to the bottom, and vice-versa)
- `:select` internal, which can be used to select a visible file when given a path as argument. Experimental

### v1.14.3 - 2022-09-12

- fix crash with token searches - Fix #504 - Thanks @FedericoStra

### v1.14.2 - 2022-07-11

- Terminal background luma determination now works on all tested unixes, including MacOS - Fix #575
- Allow `:focus` based verbs to take a pattern - Fix #389

### v1.14.1 - 2022-07-06

Due to a technical problem, background color based skin selection is disabled on non linux systems.

### v1.14.0 - 2022-07-05

#### Major Feature: imports
A configuration file can now import one or several other ones.
An import can have a condition on the terminal's background color, which makes it possible to import either a dark or a light theme depending on the current terminal settings.
You're also encouraged to split your configuration in several files, as is now done for the default configuration.
### Minor changes
- fix `--cmd` not working (it was accidentally renamed in `--commands`, `-c` was still working) - Fix #570

### v1.13.3 - 2022-06-19

- fix `default_flags` in conf not working anymore - Fix #566

### v1.13.2 - 2022-06-18

- advice to hit alt-i and|or alt-h when no file is visible - Fix #556
- examples on search modes in help screen - Fix #559
- list of syntactic themes in default conf
- the --file-export-path launch argument which was deprecated since broot 1.6 has been removed (redirect the output of broot instead)
- better built-in verbs for Windows - Thanks @Spacelord-XaN
- take the .git/info/exclude file into account for ignoring - Thanks @refi64

Note: The released archive doesn't include an Android build - see https://github.com/Canop/broot/issues/565

### v1.13.1 - 2022-05-30

- fix alt-enter failing to cd to directory

### v1.13.0 - 2022-05-29

- close the staging area when it's emptied with a verb (e.g. on `:rm`)
- format files counts with thousands separator - Fix #549
- try verbs in order allowing some with filters before one without - Fix #552

### v1.12.0 - 2022-05-05

- `:stage_all_files` internal, adding to the staging area all the files verifying the current pattern. Mapped by default to ctrl-a

### v1.11.1 - 2022-04-04

- fix broot not being usable while an image is being opened by hitting enter on linux - Fix #530

### v1.11.0 - 2022-04-02

- sorting by type, with 3 new internals: `:sort_by_type_dirs_first`,  `:sort_by_type_dirs_last`, and `:sort_by_type`. The last one lets you toggle between no sort, sorting by type with directories first, and sorting by type with directories last. - Fix #467

### v1.10.0 - 2022-03-29

- verb filtering on file extension - Fix #508
- don't quit on tiny terminals - Fix #511
- fix the `capture_mouse` config item which was described in documentation but not usable (the non documented `disable_mouse_capture` argument was working and is kept for compatibility)

### v1.9.4 - 2022-03-07

- don't query size of remote filesystems anymore. This fixes some 10 seconds hangs in some cases (e.g. filesystem screen) when a remote filesystem is unreachable

### v1.9.3 - 2022-02-15

- keep same line visible in preview when resizing
- `:previous_dir` and `:next_dir` internals - Fix #502

### v1.9.2 - 2022-01-23

- instead of crashing on syntect panic in code preview, fall back to unstyled text - Fix #485
- fix files in worktree missing from git statuses - Fix #428

### v1.9.1 - 2022-01-07

- fix a few problems of speed, flickering and uncleaned background with high resolution image preview

### v1.9.0 - 2022-01-06

- total search (launched with ctrl-s) shows all matches - This is experimental and might be reversed, opinions welcome
- kitty graphics protocol used for high definition image rendering on recent enough versions of WezTerm - Fix #473
- fix syntaxic preview of Python files broken by comments - Fix #477
- home key bound to :input_go_to_start, end key bound to :input_go_to_end - Fix #475

### v1.8.1 - 2021-12-29

- fix regex pattern automatically built from content pattern when going from a tree search to a file preview isn't escaped - Fix #472

### v1.8.0 - 2021-12-26
- alt-i bound to toggle_git_ignore
- alt-h bound to toggle_hidden
- text previews switches to hexa when there are not printable chars (eg escape sequences)

### v1.7.5 - 2021-12-16
- Make the "clipboard" feature non default again, as it proves to make compilation harder on some platform. I still distribute executables with this feature and you can still try the compilation with `cargo install broot --features "clipboard"`

### v1.7.4 - 2021-12-01
- Fix 1 or 2 characters of the right ASCII column in hex view sometimes lost

### v1.7.3 - 2021-11-19
- Fix rendering artefacts on Windows, like a duplicate input line

### v1.7.2 - 2021-11-18
- include more syntaxes for preview of code files (using the list from the bat project) - Fix #464

### v1.7.1 - 2021-11-07
- fix clipboard filled with dummy value on launch on X11

### v1.7.0 - 2021-10-30
- "clipboard" feature now default (can still be removed at compilation with  `--no-default-features`)
- fix clipboard features not working on some recent linux distributions
- you can now select part of the input with shift arrows or by dragging the mouse cursor
- new internals: input_selection_cut and input_selection_copy (not bound by default)

### v1.6.6 - 2021-10-22
- make it possible to rebind left and right arrow keys without breaking usage in input - Fix #438

### v1.6.5 - 2021-10-01
- improve decision on whether to trim root - Fix #434
- better make the tree's selected line visible

### v1.6.4 - 2021-10-01
- better scrolling behaviors - Fix #419
- fix special-path::Enter for symlinks - Fix #448

### v1.6.3 - 2021-08-02
- hjson: fix bad parsing on tab before colon
- now checks all args of externals are set, doesn't use the raw {arg}

### v1.6.2 - 2021-07-31
- broot reads now both the TERM and TERMINAL env variables to try determine whether the terminal is Kitty
- using `:toggle_device_id`, you can display the device id of files (unix only)
- fix a few problems with filesystems analysis by upgrading lfs-core to 0.4.2 - Fix #420
- a few minor rendering improvements

### v1.6.1 - 2021-06-23
- fix compilation on freeBSD
- fix `:filesystems` view not listing disks whose mount point has a space character
- fix panic on searching `cr/.*` if a file starts with an empty line - Fix #406
- fix preview of linux pseudo-files
- identify "RAM" and "encrypted" disks in `:filesystems` view

### v1.6.0 - 2021-06-16
- `{root}` argument (current tree root) can be used in verb patterns - Fix #395
- `working_dir` verb attribute - Fix #396
- client-server mode fixed, no longer feature-gated (but still only available on unix like systems)
- broot tries to keep same selection on option changes
- `:tree_up` and `:tree_down` internals, mapped to ctrl-up and ctrl-down - Fix #399
- better handling of auto color mode: two separate behaviors: for app running and for export when leaving - Fix #397
- remove the deprecated `--no-style` launch argument (use `--color no` instead)
- deprecate the `--out` argument (redirecting the output is the recommended solution)
- fix a few minor bugs

### v1.5.1 - 2021-06-03
- fixed a few problems with the `:del_word_right` internal

### v1.5.0 - 2021-06-02
- new `auto_exec` verb property: a non-auto_exec verb isn't executed directly on a keyboard shortcut but fills the input so that it may be edited before execution on enter key
- add support for backtab key (by default it's bound to :previous_match)
- `:rename` built-in verb, best used with its keyboard shortcut F2
- new standard verb arguments: `{file-stem}`, `{file-extension}`, and `{file-dot-extension}`,
- new `:toggle_second_tree` internal - Fix #388
- total size of staging area computed and displayed if sizes displayed elsewhere
- new `file_sum_threads_count` conf property to define the number of threads used for file summing (size, count, last modified). The goal is to more easily search what's the best value depending on the cpu, OS and disk type/speed
- `:input_clear` internal - Fix #24

### v1.4.0 - 2021-05-11
- the default (non prefixed) search is now "path fuzzy" instead of "name fuzzy". You can still change the default mode and mode bindings in the config. This was done after a survey in chat.
- new "unordered tokens" search type: `t/ab,cd` searches for tokens "ab" and "cd" in any order and case insensitive in the subpath, matches for example `src/dcd/Bab.rs` - Fix #378
- fix search modes configuration removing all default mappings - Fix #383
- conf / quit_on_last_cancel to allow quitting with esc when there's nothing to cancel - Fix #380
- new `parent` skin entry for the part of the sub-path before the file name (visible when you search on subpath)
- when a content search has been done, opening a file with a compatible command (like the standard `:edit`) opens on the first line with a match

### v1.3.1 - 2021-04-30
- fix `:previous_match` not jumping over indirect matches - Fix #377
- fix typing a prefixed pattern then emptying it while keeping the prefix doesn't remove filtering - Fix #379
- fix shifted matching chars highlighting with regex patterns when showing icons - Fix #376

### v1.3.0 - 2021-04-28
#### Minor changes:
- modal mode: revert to command mode on command execution - Fix #372
- modal mode: when in command mode, '/' only enters input mode and is never appended to the input
- better handle failing external programs when not leaving broot
#### Major feature: staging area
You may add files to the staging area then apply a command on all of them. This new feature is described [here](https://dystroy.org/broot/staging-area).
Several verbs have been added. Type "stag" in help to see them and their keyboard shortcuts.

### v1.2.10 - 2021-04-03
- fix shift based key shortcuts - Fix #363
- check there's another panel before executing verbs with other-panel argument - Fix #366

### v1.2.9 - 2021-03-18
- fix panic on `:input_del_word_left` - Fix #361
- remove diacritics and normalize unicode from input on fuzzy search (an unnormalized string with unwanted diacritics most often happen when you paste a string in the input)

### v1.2.8 - 2021-03-11
- it's possible to define several key shortcuts for a verb, using the "keys" property
- improvements of fuzzy matching

### v1.2.7 - 2021-02-28
- don't ask again for installation if no sourcing file has been found

### v1.2.6 - 2021-02-27
- clipboard features (copy and paste verbs) now work on Android/Termux (needs the Termux API to be installed)
- fix a compilation problem on non gnu windows - Thanks @Stargateur
- obey '--color no' even in standard application mode. In that case, automatically enable selection marks or you wouldn't know what line is selected

### v1.2.5 - 2021-02-25
- fix style characters being written in `--no-style` mode - Fix #346
- replace `--no-style` with `--color` taking `yes`, `no` or `auto`, with detection of output being piped in `auto` mode (default). `--no-style` is still usable but it's not documented anymore - Fix #347
- fix wrong version number written in log file - Fix #349
- by default the number of panels is now limited to 2 (can be changed in conf with `max_panels_count`). The goal is to improve the global ergonomics for the most common (universal?) use case - Fix #345

### v1.2.4 - 2021-02-14
- :line_down_no_cycle and :line_up_nocycle. They may be mapped instead of :line_up and :line_down when you don't want to cycle (ie arrive on top when you go down past the end of the tree/list) - Fix #344
- fix selected line number rendering in text preview

### v1.2.3 - 2021-02-06
- special paths in "no-enter" or "hide" aren't counted when summing sizes or dates. It's a compromise: it makes all sums a little slower, especially if you have a lot of special paths or complex ones, but it allows skipping over the very slow disks and thus makes some cases much faster - Fix #331
- br fish shell function uses shell completion of broot
- tree height in `:pt` now applies even when there are more root items (thus truncating the tree) - Fix #341
- fix the F5 and F6 shortcuts (copy and move between panels) in the default configuration

### v1.2.1 - 2021-01-27
- allow dashes instead of underscores in conf property names. This fixes a regression as "special-paths", "ext-colors" and "search-modes" were defined with a dash up to version 1.0.7. Now both spellings are OK - Fix #330
- fix some problems with paths containing spaces (regression since 1.1.11)- Fix #329

### v1.2.0 - 2021-01-14
- experimental "modal mode" (or "vim mode") in broot. See https://dystroy.org/broot/vim_mode/
- fix mouse staying captured during external app execution - Fix #325

### v1.1.11 - 2021-01-07
- fix handling of rules starting with '/' in the global gitignore - Fix #321
- alt-c now mapped to the new :copy_line verb which, when in tree, puts the selected path in the clipboard and, when in text preview, puts the selected text line in the clipboard - Fix #322
- it's possible to define verb execution patterns as arrays instead of simple strings, to avoid having to escape quotes - Fix #319

### v1.1.10 - 2020-12-24
broot now accepts both TOML and Hjson files for configuration. Default is Hjson. I explain the change [here](https://dystroy.org/blog/hjson-in-broot/)

### v1.0.9 - 2020-12-19
- fix handling on quotes in configured verbs - Fix #316

### v1.0.8 - 2020-12-01
- when sizes are displayed (eg on `br -s`), show size of root line and root filesystem info
- modified size cache management makes some size computations faster
- sizes (and dates and counts) are progressively displayed

### v1.0.7 - 2020-11-27
* :previous_same_depth and :next_same_depth internals
* in kitty terminal, image preview is high definition

### v1.0.6 - 2020-11-19
* optional icons, thanks to @asdf8dfafjk (@fiAtcBr on Miaou) - See https://dystroy.org/broot/icons
* dev.log renamed into broot.log
* `:line_up` and `:line_down` accept an optional count as argument - Fix #301

### v1.0.5 - 2020-11-05
* in case of IO error when previewing a file, display the error instead of quitting
* fix regression related to display of texts with characters taking several columns
* preview now supports opening system files with size 0 (eg /proc "files")

### v1.0.4 - 2020-10-22
* don't use absolute paths for built-in verbs
* fix freeze on circular symlink chains
* `:filesystems` (alias `:fs`) display all mounted filesystems in a filtrable view. You can enter to browse at the mount point (unix only for now)
* `:toggle_root_fs` (alias `:rfs`) toogles showing information on the filesystem of the current directory
* filesystem information (mainly size and usage) related to the current filesystem displayed in whale-spotting mode

### v1.0.3 - 2020-10-07
* change the syntax of cols_order in conf
* fix left key moving the cursor to start of input (instead of just one char left)

### v1.0.2 - 2020-10-04
* `cr/` patterns search on file content with regular expressions
* search modes and their prefixes listed in help

### v1.0.1 - 2020-09-30
* don't apply .gitignore files (including the global one) when not in a git repository - Fix #274
* the "clipboard" optional feature adds:
	* the `:copy_path` verb which copies the selected path to the clipboard (mapped to alt-c)
	* the `:input_paste` verb which inserts the clipboard content in the input (mapped to ctrl-v)
* it's now possible to define verbs executing sequences of commands - Fix #277
* fix opening of link of link - Fix #280
* broot is now compatible with Android, you can use it on Termux for example
* help page lists all optional features enabled at compilation
* list of verbs in help page is searchable

### v1.0.0 - 2020-09-01
- nothing new, which is better when you want to call your software stable

### v0.20.3 - 2020-08-23
- fix a few problems with tabulation rendering
- fix a few cases of files being called "huge" while they're only very big

### v0.20.2 - 2020-08-18
- fix esc key not removing the filter in text preview

### v0.20.1 - 2020-08-18
- completion of the "client-server" feature
- the tree tries to keep the selection when you remove a filter using the esc key
- :focus now has a shortcut for when a file is selected too: ctrl-f
- show_selection_mark preference in config (mostly for cases the background isn't clear enough)
- **breaking change:** The working directory of external processes launched by broot isn't set anymore by default.
If you want it to be changed, add `set_working_dir = true` to the verb definition.

### v0.20.0 - 2020-08-16
- it's now possible to launch a terminal as sub process from broot (and be back to broot on exit)
- the selected directory is now the working dir for subprocess launched from broot
- images are previewed as such
- :preview_binary, :preview_text, and :preview_image verbs allow the choice of previewing mode
- fix a possible panic in previewed files on displaying fuzzy pattern matches

### v0.19.4 - 2020-07-31
- don't install the br shell function when --outcmd is set or $BR_INSTALL is "no" - Fix #265
- more relevant status hints - Fix #261

### v0.19.3 - 2020-07-27
- refined search in preview interaction (see blog https://dystroy.org/blog/broot-c-search/)

### v0.19.2 - 2020-07-26
- "client-server" feature (see client-server.md)
- preview's pattern is kept when changing file
- selected line in preview, interesting when removing the pattern (to see what's around a match)
- faster availability of huge files in preview
- search in preview now interrupted by key events (just like the trees)
- a content search in a tree is propagated as a regex in a preview on :panel_right (ctrl-right)
- syntax theme choice in conf.toml
- {line} in a verb execution pattern refers to the line number

### v0.19.1 - 2020-07-17
Force trimming root when searching (trimming root when not searching is no longer the default)

### v0.19.0 - 2020-07-16
#### Major feature: the preview panel
Hit ctrl-right when a file is selected and you get the preview.

### v0.18.6 - 2020-07-10
- `[ext-colors]` section in config
- a few minor fixes and changes

### v0.18.5 - 2020-07-05
- git status takes into account overloading of enter and alt-enter
- a few minor fixes and changes

### v0.18.4 - 2020-07-02
- `--git-status` launch option
- fix rendering on windows

### v0.18.3 - 2020-06-30
Faster rendering (0.18.2 made it slower on some terminals)

### v0.18.2 - 2020-06-29
Remove flickering

### v0.18.1 - 2020-06-28
Column order is now configurable - Fix #127

### v0.18.0 - 2020-06-26

#### Major change: Recursive last modified date computation
The date of directories is now the modification date of the last modified inner file, whatever its depth. This is computed in the background and doesn't slow your navigation.

#### Major change: Sort mode
Size can now be displayed out of sort mode, which concerns either size or dates.

There are new launch arguments:
* `--sort-by-count` : sort by number of files in directories
* `--sort-by-date` : sort by dates, taking content into account (make it easy to find deep recent files)
* `--sort-by-size` : sort by size
* `--whale-spotting` or `-w` : "whale spotting" mode (sort by size and show all files)

The `-s` launch argument now works similarly to -d or -p : it doesn't activate a sort mode but activates showing the sizes. `-s` has been replaced with `-w`.

Similarly new verbs have been defined:
* `:toggle_counts`, with shortcut `counts` shows the number of files in directories
* `:toggle_sizes`, with shortcut `sizes` shows the sizes of files and directories
* `:sort_by_count` has for shortcut `sc`
* `:sort_by_date` has for shortcut `sd`
* `:sort_by_size` has `ss` as shortcut
* `:no_sort` removes the current sort mode, if any

### v0.17.0 - 2020-06-21
#### Major feature: keep broot open behind terminal editors
If you now open vi or emacs from broot with `leave_broot = false` you should
be back in broot after you quit the editor - Fix #34 - Fix #144 - Fix #158
#### Minor changes:
- it's possible to define input edition shortcuts - Fix #235
- MacOS: config directory for new install is ~/.config/broot - Fix #103

### v0.16.0 - 2020-06-20
#### Major feature: composite patterns
It's now possible to use logical operators on patterns.

For example:
* `!/txt$/` : files whose name doesn't end in "txt"
* `carg|c/carg` : files whose name or content has "carg"
* `(json|xml)&c/test` : files containing "test" and whose name fuzzily contains either "json" or "xml"
The document contains other examples and precisions.

### v0.15.1 - 2020-06-12
- fix some problems related to relative paths in built in cp and mv

### v0.15.0 - 2020-06-12
#### Major feature: new input syntax - Breaking Change
New search modes (see https://dystroy.org/broot/input/#the-filtering-pattern) :
	- fuzzy or regex on sub-paths (the path starting from the displayed root)
	- search in file content
- it's possible to configure how search modes are selected in config
- search pattern characters can be escaped with a '\'
#### Minor changes:
- tab goes to next direct match when there's no verb in input - Fix #234
- `:open_stay_filter` to be used if you want to keep the pattern when you navigate - Fix #240
- mouse capture can be disabled with `capture_mouse = false` - Fix #238
- several small fixes

### v0.14.2 - 2020-06-01
- `apply_to` verb property - fix #237

### v0.14.1 - 2020-05-29
- fix uppercase letters ignored in input field

### v0.14.0 - 2020-05-29
#### Major feature: `:focus` verb
This verb can be called, and parameterized, with a path as argument, which makes it possible to have a shortcut to a specific location.
As a result, the specific `:focus_user_home` and `:focus_root` verbs have been removed (`:focus ~` works on all OS).
#### Major feature: panels!
There are three major ways to open a new panel:
- by using ctrl-left or ctrl-right, which can also be used to navigate between panels
- when a verb is edited, by using ctrl-p, which opens a panel which on closure will fill the argument
- by using any verb with a bang. For example `:focus! ~` or `:!help`
When you have two panels, you may use some new verbs like :copy_to_panel which copies the selection to the selected location in the other panel.
Many new verbs and functions are related to panels but broot can still be used exactly as before without using panels.
#### Major feature: autocompletion
Using the Tab key you can complete verbs or paths
#### Major feature: special paths
Some paths can be handled in a specific way. Fix #205 and #208
You can for example decide that some slow disk shouldn't be entered automatically
#### Minor changes:
- date/time format configurable - Fix #229
- esc doesn't quit broot anymore (by popular demand)
It's probably a good idea to remove your existing conf.toml file so that broot creates a brand new one with suggestions of shortcuts.

### v0.13.6 - 2020-04-08
- ignore diacritics in searches - Fix #216

### v0.13.5 - 2020-03-28
- right key open directory, left key gets back (when input is empty) - Fix #179
- replace ~ in path arguments with user home dir - Fix #211
- use $XDG_CONFIG_HOME/git/ignore when the normal core.excludesFile git setting is missing - Fix #212
- add a man page to archive - Fix #165

### v0.13.4 - 2020-03-13
- support for an arg made of an optional group - Fix #210

### v0.13.3 - 2020-02-27
- fix a compilation problem related to dependency (termimad) version

### v0.13.2 - 2020-02-16
- fix -i and -I launch arguments being ignored (fix #202)

### v0.13.1 - 2020-02-08
- fix background not always removed when skin requires no background (Fix #194)

### v0.13.0 - 2020-02-05
#### Major change: git related features
- `:show_git_file_info` compute git repo statistics and file statuses. Statistics are computed in background and cached.
- `:git_diff` verb launching `git diff {file}`
- `:git_status` filter files to show only the ones which are relevant for `git status` (warning: slow on big repositories)
#### Major change: rewamped launch flags
Several new launch flags have been added, mostly doing the opposite of previous ones (eg `-S` negates `-s`) and a new entry in the conf.toml lets you define default flags (which can be overridden by the ones you pass on the command line).
Do `br --help` to view the complete list of flags.
#### Minor changes:
- on refresh or after command, if the previously selected path can't be selected (missing file, probably) then the previous index will be kept if possible
- alt-enter can be rebinded (users should not do that without binding `:cd`, though)

### v0.12.2 - 2020-01-29
- fix Ctrl-J being interpreted as Enter (fix #177)

### v0.12.1 - 2020-01-25
- fix panic on some inputs starting with a `/` (Fix #175)
- TAB key now jumps to direct matches only
- `--conf` arg to launch broot with specific config file(s) (fix #141)

### v0.12.0 - 2020-01-19
- **breaking change:** commands given with `--cmd` must be separated (default separator is `;`)
- fix some cases of terminal let in a bad state on errors (thanks Nathan West)
- bring some changes to the fish shell function and its installation (PR #128)
- consider path `$ZDOTDIR/.zshrc` for zsh shell function sourcing (fix #90)
- don't use .gitignore files of parent repositories
- change default value of the toggle_trim_root to false (fix #106 but might be reverted)
- `:print_relative_path` verb (fix #169, thanks Roshan George)
- `:chmod` verb

### v0.11.9 - 2020-01-15
- fix a case of bad selection after search followed by interrupted search (#147)
- `--set-install-state` can be used in tests or manual installs to set the installation state
- Raspberry now a default target available in installation page
- fix a regression: `br -s` not finishing computing size until receiving an event
- display the real size of sparse files (fix #102)

### v0.11.8 - 2020-01-12
- set different skins for the r, w and x parts of the mode (permission)
- compatibility with freeBSD
- generate shell completion scripts on build (deep into the target directory)
- `--print-shell-function` launch argument to print the shell functions to stdout

### v0.11.7 - 2020-01-11
- fix cancelled verbs possibly executed (fix #104) (major dangerous bug)

### v0.11.6 - 2020-01-10
- backspace was previously bound to :back if not consumed by input. This is removed
- fix unsignificative event interpreted as previous event repetition
- fix wrong background applied on sizes in tree display
- allow env vars used in verb execution to contain parameters (fix #114)
- allow the use of arrow keys as triggers for verbs (fix #121)
- fix scroll adjustment when using the arrow keys (when there's a scrollbar) (fix #112)

### v0.11.5 - 2020-01-10
- keep same path selected when lines are reordered (such as when directory sizes are computed
- changed the skin used before installation so that it works better on white backgrounds

### v0.11.4 - 2020-01-09
- make :open_stay and :open_leave work in help screen (applying on configuration file)
- Mac/fish: use ~/.config/fish even on systems where the config home is usually different
- Mac/bash: add .bash_profile to the list of possible sourcing files
- define ctrl-c as a new way to quit

### v0.11.3 - 2020-01-09
- fix the 'n' answer being ignored when user is asked authorization

### v0.11.2 - 2019-12-30
- fix alt-enter not recognized on some computers

### v0.11.0 - 2019-12-21
New major feature: the `:total_search` verb, normally triggered with *ctrl-s*: done after a search it repeats it but looks at **all** the children, even if it's long and there were a lot of matches

### v0.10.5 - 2019-12-20
- should not panic anymore when opening arbitrary files on server
- allow more keys for verbs. For example you can use `enter` (this one won't apply on directories but only on files)
- display all possible verb completions in status
- don't query the terminal size after start: use the new Resize event of Crossterm

### v0.10.4 - 2019-12-16
* fuzzy search performance improvement
* verb invocation now optional so that a verb can be defined to just introduce a keyboard shortcut
* owner and group separately skinned
* screen redrawn on resize (but tree not recomputed, you may want to do F5 to have the best sized tree)
* changes in br shell function storage and sourcing from fish, bash, and zsh. Fixes #39 and #53.
Note that broot will ask you again to install the br function

### v0.10.3 - 2019-11-27
* fix panic on doing `:rm` on the last child of current root
* refactor help page generation using Termimad templates
* clear help background when terminal was resized between redraws

### v0.10.2 - 2019-11-15
* colored status line
* better handling of errors when opening files externally
* spinner replaced with an explicit text
* `:parent` no longer keeps the filter (this was too confusing)
* new `:up` command, focusing the parent of the current tree root
* `$PAGER` used in default config. Fix #20
* default conf links to the white background skin published on web site
* new "default" entry in skin, to define a global background replacing the terminal's one

### v0.10.1 - 2019-11-04
* incorporate crossterm 0.13.2 to fix a regression in vi launch (see https://github.com/Canop/broot/issues/73)

### v0.10.0 - 2019-11-03
* moved to the crossterm 0.13 and termimad 0.7.1
* broot runs on stderr,
* broot can run in a subshell

Those changes allow tricks like `my_unix_command "$(broot)"` when you do `:pp` to print the path on stdout from broot

### v0.9.6 - 2019-09-20
* smarter cut of the status line when it doesn't fit the console's width
* fix mouse click on the status line crashing broot
* prevent the best match from being hidden inside "unlisted" matches

### v0.9.5 - 2019-09-15
* keyboard keys & shortcuts can be defined for more actions, all built-in verbs documented in website
* paths built from verb arguments are now normalized

### v0.9.4 - 2019-09-13
New internal verbs like :focus_root, :focus_user_home, :refresh, :select_first
You can define triggering keys for verbs.

For example you can add those mappings:

	[[verbs]]
	invocation = "root"
	key = "F9"
	execution = ":focus_root"

	[[verbs]]
	invocation = "home"
	key = "ctrl-H"
	execution = ":focus_user_home"

	[[verbs]]
	invocation = "top"
	key = "F6"
	execution = ":select_first"

	[[verbs]]
	invocation = "bottom"
	key = "F7"
	execution = ":select_last"

Then, when doing <key>Ctrl-H</key>, you would go to you user home (`~` when on linux) and <key>F7</key> would select the last line of the tree.

A few more keys are defined as default, like F1 for `:help` and F5 for `:refresh`.

### v0.9.3 - 2019-08-02
Launching broot with `--sizes` now sets a set of features enabling fast "whale spotting" navigation

### v0.9.2 - 2019-07-31
Fix non consistent builds due to lack of precise versioning in crossterm subcrate versioning

### v0.9.1 - 2019-07-29
#### Major change
* A new syntax allows specifying verbs which can work on relative paths or absolute paths alike.
For example the old definition of `cp` was

	invocation = "cp {newpath}"
	execution = "/bin/cp -r {file} {parent}{newpath}"

and it's now

	invocation = "cp {newpath}"
	execution = "/bin/cp -r {file} {newpath:path-from-parent}"

The :path-from-parent formatting means the token will be interpreted as a path, and if it's
not starting with a / will be prefixed by the parent path.
It's possible to also use `{subpath:path-from-directory}` where directory is parent only if
the selected file isn't a directory itself.
#### Minor changes
- shift-tab selects the previous match
- mouse wheel support (selection in tree, scroll in help)
- the input field handles left/right arrow keys, home/end, click, and delete

### v0.9.0 - 2019-07-19
#### Major change
The logic behind opening has changed to allow easier opening of files in non terminal applications without closing broot.

**Old behavior:**
- in case of enter or double-click
   - on a directory: open that directory, staying in broot
   - on a file: open the file, quitting broot
- in case of alt-enter
   - on a directory: cd to that directory, quitting broot
   - on a file: cd to that file's parent directory, quitting broot

**New behavior:**
- in case of enter or double-click
   - on a directory: open that directory, staying in broot
   - on a file: open that file in default editor, not closing broot
- in case of alt-enter
   - on a directory: cd to that directory, quitting broot
   - on a file: open that file in default editor, quitting broot
#### Minor change
- Hitting `?` more directly opens the help screen, even when executing a verb

### v0.8.6 - 2019-07-03
- Hitting enter when first line is selected, or clicking it, goes up to the parent directory
- detect and color executable files on windows
- new toggle to display dates of files (last modification)
- a few small improvements

### v0.8.5 - 2019-06-20
- minor cosmetic changes (this version was mostly released to ensure consistency with termimad's crate)

### v0.8.4 - 2019-06-17
- apply verbs on link files, not on their targets (rm some_link was dangerous)

### v0.8.3 - 2019-06-16
- mouse support: click to select, double-click to open

### v0.8.2 - 2019-06-15
- fix wrong result of scrolling when help text fits the screen

### v0.8.1 - 2019-06-10
- change default skin to only use highly compatible colors
- allow ANSI colors in skin configuration

### v0.8.0 - 2019-06-07
Half broot has been rewritten to allow Windows compatibility. Termion has been replaced with crossterm.

### v0.7.5 - 2019-04-03
- try to give arguments to verbs executed with --cmd
- Hitting <enter> no longer quits when root is selected (many users found it confusing)

### v0.7.4 - 2019-03-25
- fix verbs crashing broot in /
- fix user displayed in place of user with :perm

### v0.7.3 - 2019-03-22
- :print_tree outputs the tree. See [documentation](https://dystroy.org/broot/documentation/usage/#export-a-tree) for examples of use
- F5 refreshes the tree

### v0.7.2 - 2019-03-15
- env variables usable in verb execution patterns, which makes it possible to use `$EDITOR` in default conf.toml
- ctrl-u and ctrl-d are now alternatives to page-up and page-down
- better error messages regarding faulty configurations
- more precise errors in case of invalid regexes
- use the OS specific file opener instead of xdg-open (concretly it means `open` is now used on MacOS)
Thanks Ophir LOJKINE for his contributions in this release

### v0.7.1 - 2019-03-08
- fix a few problems with the count of "unlisted" files

### v0.7.0 - 2019-03-07
##### Major changes
- verbs can now accept complex arguments. This allows functions like mkdir, mv, cp, etc. and your own rich commands
- custom verbs can be executed without leaving broot (if defined with `leave_broot=false`)
##### Minor changes
- Ctrl-Q shortcut to leave broot
- fix a case of incorrect count of "unlisted" files

### v0.6.3 - 2019-02-23
- `br` installer for the fish shell
- faster directory size computation (using a pool of threads)
- fix alt-enter failing to cd when the path had spaces
- executable files rendered with a different color

### v0.6.2 - 2019-02-18
- all colors can be configured in conf.toml

### v0.6.1 - 2019-02-14
- complete verbs handling in help screen
- faster regex search
- fix missing version in `broot -V`

### v0.6.0 - 2019-02-12
##### Major changes
- broot now installs the **br** shell function itself *(for bash and zsh, help welcome for other shells)*
- new verb `:toggle_trim_root` allows to keep all root children
- verbs can refer to `{directory}` which is the parent dir when a simple file is selected
- user configured verbs can be launched from parent shell too (like is done for `cd {directory}`)
##### Minor changes
- allow page up and page down on help screen
- fuzzy pattern: increase score of match starting after word separator
- better handle errors on a few cases of non suitable root (like passing an invalid path)
- clearer status error on `:cd`. Mentions `<alt><enter>` in help
- add a scrollbar on help screen

### v0.5.2 - 2019-02-04
- More responsive on slow disks
- fix a link to documentation in autogenerated conf

### v0.5.1 - 2019-02-03
- alt-enter now executes `:cd`

### v0.5.0 - 2019-01-30
- patterns can be regexes (add a slash before or after the pattern)
- configuration parsing more robust
- no need to put all verbs in config: builtins are accessible even without being in config
- no need to type the entire verb shortcut: if only one is possible it's proposed
- verbs with {file} usable in help state: they apply to the configuration file
- clear in app error message when calling :cd and not using the br shell function
- bring back jemalloc (it's faster for broot)
- more precise display of file/dir sizes

### 0.4.7 - 2019-01-21
- fix some cases of panic on broot quitting
- new `--cmd` program argument allows passing a sequence of commands to be immediately executed (see [updated documentation](https://github.com/Canop/broot/blob/master/documentation.md#passing-commands-as-program-argument))
- better handling of symlink (display type of target, show invalid links, allow verbs on target)
- compiled with rustc 1.32 which brings about 4% improvements in perfs compared to 1.31

### v0.4.6 - 2019-01-12
- fix configured verbs not correctly handling paths with spaces
- fix `:q` not instantly quitting broot when computing size
- hit enter on tree root correctly quits broot

### v0.4.5 - 2019-01-11
- Faster search, mainly

### v0.4.3 - 2019-01-08
- Faster search and directory size computation.

### v0.4.2 - 2019-01-07
- more complete search if time allows
- search pattern kept after verb execution

### v0.4.1 - 2019-01-07
- first public release
